local function html_encode(str)
	local repls = {
		[ [[%"]] ] = "&quot;",
		["%("] ="&#40;",
		["%)"] = "&#41;",
		["%["] = "&#91;",
		["%]"] = "&#93;",
		[ [[%\]] ] = "&#92;",
	}
	for from, to in pairs(repls) do
		str = str:gsub(from, to)
	end
	return str
end

add_interceptor("/kolproxy-add-log-note", function()
	local notes = ascension["__log notes"] or {}
	if params.note then
		table.insert(notes, { turn = turnsthisrun(), note = html_encode(params.note) })
		ascension["__log notes"] = notes
	end
	local notehtmltbl = {}
	for x in table.values(notes) do
		table.insert(notehtmltbl, "<li>[" .. x.turn .. "] " .. x.note .. "</li>")
	end
	return [[
<html>
<body>
<ul>
]] .. table.concat(notehtmltbl, "\n") .. [[
</ul>
<form action="/kolproxy-add-log-note">
<textarea name="note" rows="5" cols="100"></textarea><br>
<input type="submit">
</form>
</body>
</html>
]], requestpath
end)
